* Starts the monitor and debugging interface

#Include "c:\program files\microsoft visual foxpro 7\foxpro.h" 

Local loShellExec, lcDirectory,lcURL
lcDirectory = Addbs(Set('directory'))
If Directory(lcDirectory + 'wwwroot\')
	lcDirectory = lcDirectory + 'wwwroot\'
EndIf

lcUrl = GetUrlFromDirectory(lcDirectory)

If !Empty(lcURL)
	Do DebugSetup
	
	Private poStatus
	poStatus = NewObject('AspStatusForm', 'AspDebug')
	poStatus.Show()
	
	Set Safety Off
	Select 0
	If !File(lcDirectory + 'ComLink.dbf')
		Create Table ComLink free (iHwnd I)
	Else
		Use ComLink Exclusive
		Zap
	EndIf
	Insert into ComLink (iHwnd) Values (_Vfp.hWnd)
	Use In ComLink
	
	loShellExec = NewObject('_ShellExecute', Home(1) + 'ffc\_Environ.vcx')
	loShellExec.ShellExecute(lcUrl)
	
	Read Events
	
	* Remove the temp link file
	Erase ComLink.dbf
EndIf

Return


******************************************
Procedure GetUrlFromDirectory(tcDirectory)
******************************************
* Retreive the URL for the local web site with the specified directory
Local lcDirectory, lcAppRoot, loWebRoot, loWebSite, lnAtPos, lcUrl
lcUrl       = ''
lcDirectory = Addbs(Lower(tcDirectory))
* Determine the Asp App Root setting for this project if it exists
lcAppRoot   = GetAppRootFromDirectory(lcDirectory)
* Determine the default website name for behind the http://localhost/
lcWebShare = JustFname(Left(lcDirectory, Rat('\', lcDirectory, 2) - 1))

If Empty(lcAppRoot)
	* Web site not found
Text To lcMessage NoShow TextMerge
The requested web site isn't found.
Do you want to create a new virtual web directory "<<lcWebShare>>"?
EndText
	If MessageBox(lcMessage, MB_YESNO + MB_ICONQUESTION, _screen.Caption) = IDYES
		* The user want's us to create a new web site with the default settings
		lcAppRoot = '/LM/W3SVC/1/ROOT/' + lcWebShare
		loWebRoot = GetObject('IIS://LocalHost/W3Svc/1/Root')
		loWebSite = loWebRoot.Create('IIsWebVirtualDir', lcWebShare)
		* Set the friendly name
		loWebSite.AppFriendlyName = 'Visual FoxPro using AspDebug powered web site'
		* Set the directory to use
		loWebSite.AppRoot = lcAppRoot
		* Application Protection: Medium
		loWebSite.AppIsolated = 2
		* Authentication Methods: Integrated Windows authentication
		loWebSite.AuthFlags = 4
		* Set the path to the specified directory
		loWebSite.Path = lcDirectory
		* Save the new site
		loWebSite.SetInfo()
	EndIf
Else
	* Web site found, check if Anonymous access is currently allowed
	lnAtPos = Atc('/W3Svc/', lcAppRoot)
	* Get a handle on the ADSI object
	loWebSite = GetObject('IIS://LocalHost' + Substr(lcAppRoot, lnAtPos))
	If Bitand(loWebSite.AuthFlags, 1) = 1
		* Bit 1 is set, this means anonymous access
Text To lcMessage NoShow TextMerge
Anonymous access is currently allowed for the website "<<lcWebShare>>".
This prevents debugging and on the fly changing code.
Do you want to disable anonymous access?
EndText
		
		If MessageBox(lcMessage, MB_YESNO + MB_ICONQUESTION, _screen.Caption) = IDYES
			* The user want to disable anonymous access
			loWebSite.AuthFlags = Bitxor(loWebSite.AuthFlags, 1)
			* Save the changes
			loWebSite.SetInfo()
		EndIf
	EndIf
EndIf

If !Empty(lcAppRoot)
	lnAtPos = Atc('/root/', lcAppRoot)
	lcUrl = 'http://LocalHost' + Substr(lcAppRoot, lnAtPos + 5)
EndIf

Return lcUrl


**********************************************
Procedure GetAppRootFromDirectory(tcDirectory)
**********************************************
Local array laADSI[1]
Local lcAppRoot, lcDirectory, lnCount, loWork
laADSI[1]   = Null
lcAppRoot   = ''
lcDirectory = Addbs(Lower(tcDirectory))
lnCount     = IIS2Arr(@laADSI, 'IIS://LocalHost/W3Svc')

For Each loWork In laADSI
	Do Case
	Case loWork.Class <> 'IIsWebVirtualDir'
		* This isn't a virtual web directory
	Case Lower(Addbs(loWork.Path)) == lcDirectory
		* This is the web directory we are looking for
		lcAppRoot = loWork.AppRoot
		Exit
	EndCase
EndFor

Return lcAppRoot
