
#Define c_ComDebugging  .t.


#If c_ComDebugging
	* Define constants for IAccesible
	#Define c_ObjIdClient   0xFFFFFFFC
	#Define c_IAccGuid      '618736E0-3C3D-11CF-810C-00AA00389B71'
#EndIf


*******************************
Define Class ComBase AS Session
*******************************

#If c_ComDebugging
	* Properties used for tracking the servers in debug mode
	nItemId                 = 0
	nItemId_ComAttrib       = 1
	nStartSeconds           = 0
	nStartSeconds_ComAttrib = 1
#EndIf


***************************
Procedure Init() as Boolean
***************************

#If c_ComDebugging
	If _VFP.StartMode = 0 And Vartype(poStatus) = 'O'
		* Notify the status window of the start of the COM request
		poStatus.OnStartRequest(This)
	EndIf
#EndIf

Return


***************************
Procedure Destroy() as Void 
***************************

#If c_ComDebugging
	If _VFP.StartMode = 0 And Vartype(poStatus) = 'O'
		* Notify the status window of the end of the COM request
		poStatus.OnEndRequest(This)
	EndIf
#EndIf

Return


************************************
Procedure GetDebugObject() as Object
************************************
* Return an object reference to a debugable copy of this COM server

Local loServer, loAcc, lnHwnd, lcGuid, loVFP, lcComLink
loServer  = Null
#If c_ComDebugging
	loAcc     = Null
	lnHwnd    = 0
	lcComLink = Addbs(JustPath(_vfp.ServerName)) + 'ComLink.dbf'

	If File(lcComLink)
		* There is an ComLink file with the required HWnd value of the design time VFP
		Use (lcComLink) In 0 Again Shared
		* Get the _VFP.hWnd value
		lnHwnd = ComLink.iHwnd
		* Close the table again
		Use In ComLink
	EndIf

	If lnHwnd <> 0
		* We where able to load the required _VFP.hWnd value
		* Declare the required Active Accessibility function
		Declare Integer AccessibleObjectFromWindow In OleAcc Integer, Integer, String, Object @
		* Convert the IAccecssible to a useable format
		lcGuid = Str2Guid(c_IAccGuid)	
		* Try to get a handle on the IAccecssible interface of _VFP
		AccessibleObjectFromWindow(lnHWnd, c_ObjIdClient, lcGuid , @loAcc)
		
		If Type('loAcc.AccChild(Int(2^31-1))') = 'O'
			* Retreive the _VFP reference from the IAccecssible object
			loVFP = loAcc.AccChild(Int(2^31-1))
			
			If Type('loVFP.Name') = 'C'
				* We got the _VFP reference, use it to check if the status form exists
				If loVFP.Eval('Type([poStatus.chkDebug.Value]) = [L]')
					* The test succeeded, retreive the object
					loServer = loVFP.Eval('CreateObject([' + This.Class + '])')
					* Set any required properties of the debug server
					This.ConfigureDebugServer(loServer)
				EndIf
			EndIf
		EndIf
	EndIf
#EndIf

* Return this server as the object to use if we are unable to reach the VFP design time environment 
loServer = Nvl(loServer, This)

Return loServer


#If c_ComDebugging
	**************************************************
	Protected Procedure ConfigureDebugServer(toServer)
	**************************************************
	* Set any extra properties required on the debugable com server

	Return
#EndIf

EndDefine
